//=============================================================================
// 쌠 ATMEL Corporation 2003. S\ς
//
// ̧:	AES.cpp
// ߲:	WC++
// o͗:
// 쐬:	28-Feb-2005	RAA (ATMELٳ)
// ύX:
//
// xҰ:	avr@atmel.com
//
// :	AESÍZ@
//
//			葽̏ɂĂ͉pLqQƂĂB
//
//=============================================================================
#include "AES.h"
#include "CreateException.h"

typedef unsigned char byte;

#define BPOLY			0x1b	// (x^8+x^4+x^3+x+1)̉8ޯāA(x^4+x^3+x+1)
#define BLOCKSIZE		16		// ޲Đł̉e

int KEYBITS;
int EXPANDED_KEY_SIZE;
int ROUNDS;
int KEYLENGTH;

byte block1[ 256 ];
byte block2[ 256 ];

byte * powTbl;
byte * logTbl;
byte * sBox;
byte * expandedKey;				// 176,208܂240޲

void CalcPowLog( byte * powTbl, byte * logTbl )
{
	byte i = 0;
	byte t = 1; 

	do {
		// wƑΐ̍Ƃ$03gp
		powTbl[i] = t;
		logTbl[t] = i;
		i++;

		// GF(2^8)t3{
		t ^= (t << 1) ^ (t & 0x80 ? BPOLY : 0);
	} while( t != 1 );			// Ii<255ۏ

	powTbl[255] = powTbl[0];	// 255='-0',254=-1,`
}

void CalcSBox( byte * sBox )
{
	byte i, rot;
	byte temp;
	byte result;

	// sBox[]̑S𖞂
	i = 0;
	do {
		// GF(2^8)ŋt
		if( i > 0 ) {
			temp = powTbl[ 255 - logTbl[i] ];
		} else {
			temp = 0;
		}

		// GF(2)ų̋ݕϊ
		result = temp ^ 0x63;					// GF(2)޸ْǉŊJn
		for( rot = 0; rot < 4; rot++ ) {
			// ]
			temp = (temp<<1) | (temp>>7);

			// GF(2)ŉ]޲Ăɒǉ
			result ^= temp;
		}

		// \Ɍʔzu
		sBox[i] = result;
	} while( ++i != 0 );
}

void CycleLeft( byte * row )
{
	// z4޲Ă1Ɏ
	byte temp = row[0];
	row[0] = row[1];
	row[1] = row[2];
	row[2] = row[3];
	row[3] = temp;
}

byte Multiply( byte num, byte factor )
{
	byte mask = 1;
	byte result = 0;

	while( mask != 0 ) {
		// maskɂė^ꂽvfޯĂ
		if( mask & factor ) {
			// GF(2)łnum݂̌̊TZ
			result ^= num;
		}

		// ޯĂ悤maskړ
		mask <<= 1;

		// num2{
		num = (num << 1) ^ (num & 0x80 ? BPOLY : 0);
	}

	return result;
}

byte DotProduct( byte * vector1, byte * vector2 )
{
	byte result = 0;

	result ^= Multiply( *vector1++, *vector2++ );
	result ^= Multiply( *vector1++, *vector2++ );
	result ^= Multiply( *vector1++, *vector2++ );
	result ^= Multiply( *vector1  , *vector2   );

	return result;
}

void MixColumn( byte * column )
{
	byte row[8] = {
		0x02, 0x03, 0x01, 0x01,
		0x02, 0x03, 0x01, 0x01
	}; // ̕KvȂ߂ɁAs̍ŏ̍s2x

	byte result[4];

	// s̊esƗ޸ق̓ς擾
	result[0] = DotProduct( row+0, column );
	result[1] = DotProduct( row+3, column );
	result[2] = DotProduct( row+2, column );
	result[3] = DotProduct( row+1, column );

	// ꎞIȌʂ̗ɕ
	column[0] = result[0];
	column[1] = result[1];
	column[2] = result[2];
	column[3] = result[3];
}

void SubBytes( byte * bytes, byte count )
{
	do {
		*bytes = sBox[ *bytes ];		// ԓ̑SĂ޲Ău
		bytes++;
	} while( --count );
}

void ShiftRows( byte * state )
{
	byte temp;

	// :(state[])͗Pʂɐ

	// 2sE1
	temp = state[ 1 + 0*4 ];
	state[ 1 + 0*4 ] = state[ 1 + 1*4 ];
	state[ 1 + 1*4 ] = state[ 1 + 2*4 ];
	state[ 1 + 2*4 ] = state[ 1 + 3*4 ];
	state[ 1 + 3*4 ] = temp;

	// 3sE2
	temp = state[ 2 + 0*4 ];
	state[ 2 + 0*4 ] = state[ 2 + 2*4 ];
	state[ 2 + 2*4 ] = temp;
	temp = state[ 2 + 1*4 ];
	state[ 2 + 1*4 ] = state[ 2 + 3*4 ];
	state[ 2 + 3*4 ] = temp;

	// 4sE3(ƁA1)
	temp = state[ 3 + 3*4 ];
	state[ 3 + 3*4 ] = state[ 3 + 2*4 ];
	state[ 3 + 2*4 ] = state[ 3 + 1*4 ];
	state[ 3 + 1*4 ] = state[ 3 + 0*4 ];
	state[ 3 + 0*4 ] = temp;
}

void MixColumns( byte * state )
{
	MixColumn( state + 0*4 );
	MixColumn( state + 1*4 );
	MixColumn( state + 2*4 );
	MixColumn( state + 3*4 );
}

void XORBytes( byte * bytes1, byte * bytes2, byte count )
{
	do {
		*bytes1 ^= *bytes2;		// GF(2)ŉZ(ƁAXOR)
		bytes1++;
		bytes2++;
	} while( --count );
}

void CopyBytes( byte * to, byte * from, byte count )
{
	do {
		*to = *from;
		to++;
		from++;
	} while( --count );
}

void KeyExpansion( byte * key, byte * expandedKey )
{
	byte temp[4];
	byte i;
	byte Rcon[4] = { 0x01, 0x00, 0x00, 0x00 };		// 萔

	// g̐擪ɕ
	i = KEYLENGTH;
	do {
		*expandedKey = *key;
		expandedKey++;
		key++;
	} while( --i );

	// temp[]Ɍ̍ŏI4޲Ă
	expandedKey -= 4;
	temp[0] = *(expandedKey++);
	temp[1] = *(expandedKey++);
	temp[2] = *(expandedKey++);
	temp[3] = *(expandedKey++);

	// g
	i = KEYLENGTH;
	while( i < BLOCKSIZE*(ROUNDS+1) ) {
		// ̑傫̔{̎n߂ȂA
		if( (i % KEYLENGTH) == 0 ) {
			CycleLeft( temp );					// 1
			SubBytes( temp, 4 );				// e޲Ēu
			XORBytes( temp, Rcon, 4 );			// GF(2)Œ萔Z
			*Rcon = Multiply( *Rcon, 0x02 );	// GF(2^8)ŁARcon̐擪޲ *= 2
		}

		// 24޲āA192ޯĂ傫Ȍ̑傫ŁA
		else if( KEYLENGTH > 24 && (i % KEYLENGTH) == BLOCKSIZE ) {
			SubBytes( temp, 4 );				// e޲Ēu
		}

		// KEYLENGTHGF(2)޲ĂZ
		XORBytes( temp, expandedKey - KEYLENGTH, 4 );

		// ʂ݂4޲Ăɕ
		*(expandedKey++) = temp[ 0 ];
		*(expandedKey++) = temp[ 1 ];
		*(expandedKey++) = temp[ 2 ];
		*(expandedKey++) = temp[ 3 ];

		i += 4;									// 4޲Ăֈʒuis
	}	
}

void Cipher( byte * block, byte * expandedKey )
{
	byte round = ROUNDS-1;

	XORBytes( block, expandedKey, 16 );
	expandedKey += BLOCKSIZE;

	do {
		SubBytes( block, 16 );
		ShiftRows( block );
		MixColumns( block );
		XORBytes( block, expandedKey, 16 );
		expandedKey += BLOCKSIZE;
	} while( --round );

	SubBytes( block, 16 );
	ShiftRows( block );
	XORBytes( block, expandedKey, 16 );
}

void aesInit( unsigned char * key, unsigned char * tempbuf )
{
	powTbl = block1;
	logTbl = tempbuf;
	CalcPowLog( powTbl, logTbl );

	sBox = block2;
	CalcSBox( sBox );

	expandedKey = block1;
	KeyExpansion( key, expandedKey );
}

void aesEncrypt( unsigned char * buffer, unsigned char * chainBlock )
{
	XORBytes( buffer, chainBlock, BLOCKSIZE );
	Cipher( buffer, expandedKey );
	CopyBytes( chainBlock, buffer, BLOCKSIZE );
}

Aes::Aes( DataBuffer & initialVector, int keyCount ) :
	keyCountM( keyCount )
{
	if( keyCount == 1 ) {
		KEYBITS = 128;
		ROUNDS = 10;
		KEYLENGTH = 16;
	} else if( keyCount == 2 ) {
		KEYBITS = 192;
		ROUNDS = 12;
		KEYLENGTH = 24;
	} else {
		KEYBITS = 256;
		ROUNDS = 14;
		KEYLENGTH = 32;
	}

	EXPANDED_KEY_SIZE = (BLOCKSIZE * (ROUNDS+1));

	for( int i = 0; i < BLOCKSIZE; ++i ) {
		chainBlockM[ i ] = initialVector.data()[ i ];
	}
}

void Aes::scheduleKey( DataBuffer key[3] )
{
	byte tempbuf[ 256 ];

	checkParity( key[0].data() );
	removeParityBits( key[0].data()  , keyTableM   );
	checkParity( key[0].data()+9 );
	removeParityBits( key[0].data()+9, keyTableM+8 );

	if( keyCountM > 1 ) {
		checkParity( key[1].data() );
		removeParityBits( key[1].data(), keyTableM+16 );
	}

	if( keyCountM > 2 ) {
		checkParity( key[2].data() );
		removeParityBits( key[2].data(), keyTableM+24 );
	}

	aesInit( keyTableM, tempbuf );
}

DataBuffer Aes::getK( int key, int index ) const
{
	// ^ꂽkeyƗ^ꂽindex̊ɏՕ8޲ĂԂB
	return DataBuffer( keyTableM + ( key == 0 ? 0 : 8+key*8 ) + index, 8 );
}

void Aes::encrypt( unsigned char * buffer, unsigned char * chainBlock ) const
{
	aesEncrypt( buffer, chainBlock );
}

void Aes::encryptBuffer( DataBuffer & buffer )
{
	for ( size_t i = 0; i < buffer.size(); i += 16 ) {
		encrypt( &buffer[i], chainBlockM );
	}
}

void Aes::removeParityBits( const unsigned char * withparity, unsigned char * withoutparity ) const
{
	int frompos, topos;

	// 8޲=64ޯď
	for( frompos = topos = 0; topos < 8*8; ++frompos, ++topos ) {
		setbit( withoutparity, topos, getbit( withparity, frompos ) );
		if( topos % 8 == 7 ) ++frompos;			// SĂ̑8ޯĂ΂B
	}
}

unsigned char Aes::getbit( const unsigned char * bits, unsigned int pos ) const
{
	if( bits[ pos/8 ] & ( 1 << (7-(pos%8)) ) ) {
		return 1;
	} else {
		return 0;
	}
}

void Aes::setbit( unsigned char * bits, unsigned int pos, unsigned char value ) const
{
	bits[ pos/8 ] &= ~( 1 << (7-(pos%8)) );
	bits[ pos/8 ] |= ( value << (7-(pos%8)) );
}

void Aes::checkParity( const unsigned char * bits ) const
{
	// 8޲Č
	for( int i = 0; i < 8; i++ ) {
		unsigned char parity = 0;
		// è ޯĎ̂܂9ޯĂ
		for( int j = 0; j < 9; j++ ) {
			parity ^= getbit( bits, i*9+j );
		}

		if( parity == 0 ) {
			unsigned char data[9];
			for( int i = 0; i < 9; i++ ) data[i] = bits[i];
			DataBuffer buf( data, 9 );
			throw new CreateException( ERROR_KEY_PARITY, buf.toHexString() );
		}
	}
}
